//*****************************************************************************
//* Copyright (c) 2001-2012 Miday Workshop All rights reserved.
//*
//* File: ExcelAcc.cpp
//*****************************************************************************

//==========================@`@ƕ\
//#define _TEST_VIEW
//==========================

#include <windows.h>
#include <new>
#include <stdlib.h>
#include <stdio.h>
#include <ole2.h>
#include <locale.h>
//#include <comdef.h>
#include "ExcelDef.h"
#include "MsgLocale.h"

#define USE_COLUMNS  0
#define USE_ROWS     1
#define USE_CELL     2
#define USE_FONT     3
#define USE_INTERIOR 4
#define USE_BOD      5
#define USE_MEARGE   6

IDispatch *MSExcel;
VARIANT ExApp, ExBooks, ExBook, ExSheets, ExArea;
VARIANT ExColumns, ExRows, ExCell, ExFont, ExInterior, ExBod, ExMearge;

//CLSID
CLSID clsid;
HRESULT hr;

//==============================================================================
//$A$1:$B$3Ŏw肳ꂽ 1,1,2,3 ̐lŕԂ
//ԂĺA-1lŁAZ̏ꍇ́AAR_FLAG1Ƃ
//==============================================================================
static int Cell_no_get(UNICHAR* areain, int *areaout) {
	int ia, ib;
	int pos[] = {AR_LEFT, AR_TOP, AR_RIGHT, AR_BOTTOM};

	for(ia=0; ia<5; ia++) {
		areaout[ia] = 0;
	}

	ib = -1;
	for(ia=0; ia<(int)MTRLEN(areain); ia++) {
		switch(areain[ia]) {
		case '$':
			ib++;
			break;
		case ':':
			//ib++;
			break;
		default:
			if (ib == 0 || ib == 2) {
				areaout[pos[ib]] = areaout[pos[ib]] * 26 + ((int)areain[ia] - (int)'A' + 1);
			} else {
				areaout[pos[ib]] = areaout[pos[ib]] * 10 + (int)areain[ia] - (int)'0';
			}
			break;
		}
	}

	if ( areaout[AR_RIGHT] > 0 || areaout[AR_BOTTOM] > 0 ) {
		areaout[AR_FLAG] = 1;
	}
	for(ia=0; ia<4; ia++) {
//		if ( areaout[AR_FLAG] == 1 ) {
		if ( areaout[ia] > 0 ) {
			areaout[ia] = areaout[ia] - 1;
		}
//		} else {
//			areaout[ia] = 0;
//		}
	}

	return NOMAL_RETURN;
}

//==============================================================================
//Excel̏I
//==============================================================================
int ExcelEnd(int flag) {
//ȉ͌
//OLE G[@@@@@@@@AutoWrapĂ΂(flag=0)
//̑̃G[@@@@@@̃t@CĂ΂(flag=1)
//------------------------------------------------------------------------------
//ubNN[Y
//------------------------------------------------------------------------------
	if ( flag == 1 ){
#ifndef _TEST_VIEW
			if ( Use_pos >= 4 ) {
				{
					VARIANT result;
					VARIANT ix;
					VariantInit(&result);
					VariantInit(&ix);
					ix.vt   = VT_I4;
					ix.lVal = false;
					if ( AutoWrap(&hr, DISPATCH_METHOD, &result, ExBook.pdispVal, L"Close", 1, ix) != 0 ) {
						VariantClear(&ix);
						VariantClear(&result);
						return OLE_ERROR;
					}
					VariantClear(&ix);
					VariantClear(&result);
				}
				Sleep(500);
			}
#endif  //_TEST_VIEW

//------------------------------------------------------------------------------
//ExcelI
//------------------------------------------------------------------------------
		if ( Use_pos >= 1 ) {
			if ( AutoWrap(&hr, DISPATCH_METHOD, NULL, MSExcel, L"Quit", 0) != 0 ) return OLE_ERROR;
			Sleep(200);
		}
	}

//------------------------------------------------------------------------------
//̈J
//------------------------------------------------------------------------------
	if ( Use_flag[USE_COLUMNS] == 1 ) {
		VariantClear(&ExColumns);
		Use_flag[USE_COLUMNS] = 0;
	}
	if ( Use_flag[USE_ROWS] == 1 ) {
		VariantClear(&ExRows);
		Use_flag[USE_ROWS] = 0;
	}
	if ( Use_flag[USE_CELL] == 1 ) {
		VariantClear(&ExCell);
		Use_flag[USE_CELL] = 0;
	}
	if ( Use_flag[USE_FONT] == 1 ) {
		VariantClear(&ExFont);
		Use_flag[USE_FONT] = 0;
	}
	if ( Use_flag[USE_INTERIOR] == 1 ) {
		VariantClear(&ExInterior);
		Use_flag[USE_INTERIOR] = 0;
	}
	if ( Use_flag[USE_BOD] == 1 ) {
		VariantClear(&ExBod);
		Use_flag[USE_BOD] = 0;
	}
	if ( Use_flag[USE_MEARGE] == 1 ) {
		VariantClear(&ExMearge);
		Use_flag[USE_MEARGE] = 0;
	}

	switch(Use_pos) {
	case 6:
		VariantClear(&ExArea);
	case 5:
		VariantClear(&ExSheets);
	case 4:
		VariantClear(&ExBook);
	case 3:
		VariantClear(&ExBooks);
	case 2:
		VariantClear(&ExApp);
	case 1:
		MSExcel->Release();
	}
	Use_pos  = 0;

//------------------------------------------------------------------------------
//COM
//------------------------------------------------------------------------------
	CoUninitialize();

	return NOMAL_RETURN;
}

//==============================================================================
//ExcelNAZ̏荞
//==============================================================================
int ExcelAcc() {
	int icl, ict, iw2, ih2;
	int ih, iw, ip, ic, ib, irc;
	int sabun;
	UNICHAR mergestr[50];
#if !defined(_MSC_VER) || _MSC_VER < 1400
	int sizew, sizew2;
#else
	size_t sizew;
#ifndef _UNICODE_TABLE
	size_t sizew2;
#endif
#endif

	Area_pos         = 0;
	Use_pos          = 0;
	for(ib=0; ib<sizeof(Use_flag)/4; ib++) {
		Use_flag[ib]          = 0;
	}
	Out_alloc        = 0;
	Out_wk_alloc     = 0;
	Clip_alloc       = 0;
	font_attr_alloc  = 0;
	cell_attr_alloc  = 0;
	setlocale( LC_CTYPE, "" );

	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	//Nbv{[h𒲂ׂ
	text_flag = ClipCheck();
	if ( text_flag == 0 ) {
		return FINISHING_MESSAGE;//f[^Ȃ
	}

//------------------------------------------------------------------------------
//COM
//------------------------------------------------------------------------------
	CoInitialize(NULL);
	Proc_pos = 0;

//------------------------------------------------------------------------------
//CLSID擾
//------------------------------------------------------------------------------
	Proc_pos = 1;
	hr = CLSIDFromProgID(L"Excel.Application", &clsid);
	ProgressView(15);

	if(FAILED(hr)) {
		return OLE_ERROR;
	}

//------------------------------------------------------------------------------
//T[o[JnAIDispatcho
//------------------------------------------------------------------------------
	Proc_pos = 2;
	hr = CoCreateInstance(clsid, NULL, CLSCTX_LOCAL_SERVER, IID_IDispatch, (void **)&MSExcel);
	if(FAILED(hr)) {
		return OLE_ERROR;
	}
	Use_pos  = 1;

	Proc_pos = 3;
	{
		VariantInit(&ExApp);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExApp, MSExcel, L"Application", 0) != 0 ) {
			VariantClear(&ExApp);
			return OLE_ERROR;
		}
//		VariantClear(&ExApp);
		Use_pos = 2;
	}

#ifdef _TEST_VIEW
//------------------------------------------------------------------------------
//o߂\
//------------------------------------------------------------------------------
		{
			VARIANT ix;
			VariantInit(&ix);
			ix.vt   = VT_BOOL;
			ix.lVal = 1;//false;//(short)0xFFFF;//
			if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ExApp.pdispVal, L"Visible", 1, ix) != 0 ) {
				VariantClear(&ix);
				return OLE_ERROR;
			}
			VariantClear(&ix);
		}
#endif  //_TEST_VIEW

//------------------------------------------------------------------------------
//WorkbooksRNVo
//------------------------------------------------------------------------------
	{
		VariantInit(&ExBooks);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExBooks, MSExcel, L"Workbooks", 0) != 0 ) {
			VariantClear(&ExBooks);
			return OLE_ERROR;
		}
//		VariantClear(&ExBooks);
		Use_pos = 3;
	}

//------------------------------------------------------------------------------
//Workbooksǉ
//------------------------------------------------------------------------------
	{
		VariantInit(&ExBook);
		if ( AutoWrap(&hr, DISPATCH_METHOD, &ExBook, ExBooks.pdispVal, L"Add", 0) != 0 ) {
			VariantClear(&ExBook);
			return OLE_ERROR;
		}
//		VariantClear(&ExBook);
		Use_pos = 4;
	}

//------------------------------------------------------------------------------
//Book̃CX^X荞
//------------------------------------------------------------------------------
//	{
//		VARIANT ix;
//		VARIANT result;
//		VariantInit(&result);
//		VariantInit(&ix);
//		ix.vt   = VT_I4;
//		ix.lVal = 1;
//		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, MSExcel, L"Workbooks", 1, ix) != 0 ) {
//			VariantClear(&ix);
//			VariantClear(&result);
//			return OLE_ERROR;
//		}
//		ExBooks.pdispVal = result.pdispVal;
//		VariantClear(&ix);
//		VariantClear(&result);
//	}

//------------------------------------------------------------------------------
//SHEET̃CX^X荞
//------------------------------------------------------------------------------
	{
		VARIANT ix;
		VariantInit(&ExSheets);
		VariantInit(&ix);
		ix.vt   = VT_I4;
		ix.lVal = 1;
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExSheets, MSExcel, L"Sheets", 1, ix) != 0 ) {
			VariantClear(&ix);
			VariantClear(&ExSheets);
			return OLE_ERROR;
		}
		VariantClear(&ix);
//		VariantClear(&ExSheets);
		Use_pos = 5;
	}

	ProgressView(20);
//------------------------------------------------------------------------------
//Nbv{[hRs[
//------------------------------------------------------------------------------
	Proc_pos = 4;
	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_METHOD, &result, ExSheets.pdispVal, L"Paste", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
		VariantClear(&result);
	}

	ProgressView(25);
	Sleep(100);

//------------------------------------------------------------------------------
//Ï̃CX^X荞
//------------------------------------------------------------------------------
	Proc_pos = 5;
	{
		VariantInit(&ExArea);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExArea, ExApp.pdispVal, L"Selection", 0) != 0 ) {
			VariantClear(&ExArea);
			return OLE_ERROR;
		}
//		VariantClear(&ExArea);
		Use_pos = 6;
	}

//------------------------------------------------------------------------------
//Ï̗ʒu荞
//------------------------------------------------------------------------------
	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExArea.pdispVal, L"Column", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
		icl = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "ʒu", 0);
		VariantClear(&result);
	}

//------------------------------------------------------------------------------
//Ï̍sʒu荞
//------------------------------------------------------------------------------
	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExArea.pdispVal, L"Row", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
		ict = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "sʒu", 0);
		VariantClear(&result);
	}

//------------------------------------------------------------------------------
//Ï̗̃CX^X荞
//------------------------------------------------------------------------------
	{
		VariantInit(&ExColumns);
		Use_flag[USE_COLUMNS] = 1;
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExColumns, ExArea.pdispVal, L"Columns", 0) != 0 ) {
			VariantClear(&ExColumns);
			Use_flag[USE_COLUMNS] = 0;
			return OLE_ERROR;
		}
//		VariantClear(&ExColumns);//ŃNA
//		Use_flag[USE_COLUMNS] = 0;
	}

//------------------------------------------------------------------------------
//Ï̗񐔎荞
//------------------------------------------------------------------------------
	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExColumns.pdispVal, L"Count", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
		Col_no = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "", 0);
		VariantClear(&result);
	}
	VariantClear(&ExColumns);//ŃNA
	Use_flag[USE_COLUMNS] = 0;

//------------------------------------------------------------------------------
//Ï̍s̃CX^X荞
//------------------------------------------------------------------------------
	{
		VariantInit(&ExRows);
		Use_flag[USE_ROWS] = 1;
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExRows, ExArea.pdispVal, L"Rows", 0) != 0 ) {
			VariantClear(&ExRows);
			Use_flag[USE_ROWS] = 0;
			return OLE_ERROR;
		}
//		VariantClear(&ExRows);//ŃNA
//		Use_flag[USE_ROWS] = 0;
	}

//------------------------------------------------------------------------------
//Ï̍s荞
//------------------------------------------------------------------------------
	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExRows.pdispVal, L"Count", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
		Row_no = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "s", 0);
//SPRINTF(testdata, sizeof(testdata), "%d %d %d %d", icl, ict, Col_no, Row_no);
//MessageBox( hWnd, testdata, "cell area", 0);
		VariantClear(&result);
	}
	VariantClear(&ExRows);//ŃNA
	Use_flag[USE_ROWS] = 0;

//------------------------------------------------------------------------------
//̈m
//------------------------------------------------------------------------------
	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		irc = ExcelEnd(1);
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	if ( AllocArea() != 0 ) {
		irc = ExcelEnd(1);
		FreeArea();
		return MEMORY_ERROR;
	}
	sabun = 60 * 1000 / Row_no;	//60%𕪊
	ProgressView(30);

//------------------------------------------------------------------------------
//̈ɒlݒ
//------------------------------------------------------------------------------
	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		irc = ExcelEnd(1);
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	for ( ih=0; ih<Row_no; ih++ ) {
		for ( iw=0; iw<Col_no; iw++ ) {
//------------------------------------------------------------------------------
//Z̃CX^X荞
//------------------------------------------------------------------------------
			{
				VARIANT ix, iy;
				VariantInit(&ExCell);
				Use_flag[USE_CELL] = 1;
				VariantInit(&ix);
				VariantInit(&iy);
				ix.vt   = VT_I4;
				ix.lVal = iw+icl;
				iy.vt   = VT_I4;
				iy.lVal = ih+ict;
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExCell, ExSheets.pdispVal, L"Cells", 2, ix, iy) != 0 ) {//X(ł͐)
					VariantClear(&iy);
					VariantClear(&ix);
					VariantClear(&ExCell);
					Use_flag[USE_CELL] = 0;
					return OLE_ERROR;
				}
				VariantClear(&iy);
				VariantClear(&ix);
//				VariantClear(&ExCell);//ŃNA
//				Use_flag[USE_CELL] = 0;
			}

//------------------------------------------------------------------------------
//tHg̃CX^X荞
//------------------------------------------------------------------------------
			{
				VariantInit(&ExFont);
				Use_flag[USE_FONT] = 1;
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExFont, ExCell.pdispVal, L"Font", 0) != 0 ) {
					VariantClear(&ExFont);
					Use_flag[USE_FONT] = 0;
					return OLE_ERROR;
				}
//				VariantClear(&ExFont);//ŃNA
//				Use_flag[USE_FONT] = 0;
			}

//------------------------------------------------------------------------------
//Interior̃CX^X荞
//------------------------------------------------------------------------------
			{
				VariantInit(&ExInterior);
				Use_flag[USE_INTERIOR] = 1;
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExInterior, ExCell.pdispVal, L"Interior", 0) != 0 ) {
					VariantClear(&ExInterior);
					Use_flag[USE_INTERIOR] = 0;
					return OLE_ERROR;
				}
//				VariantClear(&ExInterior);//ŃNA
//				Use_flag[USE_INTERIOR] = 0;
			}

//------------------------------------------------------------------------------
//Z̕荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExCell.pdispVal, L"Text", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}

#ifdef _UNICODE_TABLE
				sizew = MTRLEN(result.bstrVal);
				if ( CharLenNewAlloc(&hyo[ih*Col_no+iw].text, sizew) == MEMORY_ERROR ) {
					VariantClear(&result);
					irc = ExcelEnd(1);
					FreeArea();
					return MEMORY_ERROR;
				}

				MTRNCPY( hyo[ih*Col_no+iw].text.data, hyo[ih*Col_no+iw].text.size+1, result.bstrVal, sizew);
				hyo[ih*Col_no+iw].text.data[sizew] = LIT_NULL_C;
#else  //_UNICODE_TABLE
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew = wcstombs( NULL, (wchar_t*)result.bstrVal, 0);
#else  //MSC
				wcstombs_s( &sizew, NULL, 0, (wchar_t*)result.bstrVal, 0);
#endif  //MSC
				if ( sizew == -1 ) {
					irc = MessageDisp( MSG_ER_CHAR_CODE );
					VariantClear(&result);
					irc = ExcelEnd(1);
					FreeArea();
					return FINISHING_MESSAGE;
				}

				if ( CharLenNewAlloc(&hyo[ih*Col_no+iw].text, sizew) == MEMORY_ERROR ) {
					VariantClear(&result);
					irc = ExcelEnd(1);
					FreeArea();
					return MEMORY_ERROR;
				}

				UNICHAR *str;
				try{
					str = new UNICHAR[sizew+1];
				}
				catch (...) {
					VariantClear(&result);
					irc = ExcelEnd(1);
					FreeArea();
					return MEMORY_ERROR;
				}
				str[0] = '\0';
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew2 = wcstombs( str, (wchar_t*)result.bstrVal, sizew + 1);
#else  //MSC
				wcstombs_s( &sizew2, str, sizew+1, (wchar_t*)result.bstrVal, sizew + 1);
#endif  //MSC
				str[sizew] = LIT_NULL_C;
				MTRCPY( hyo[ih*Col_no+iw].text.data, hyo[ih*Col_no+iw].text.size+1, str);
				delete str;
#endif  //_UNICODE_TABLE
				VariantClear(&result);
//char testdata[1000];
//SPRINTF(testdata, sizeof(testdata), "text %d %d %s", iw, ih, hyo[ih*Col_no+iw].text.data);
//MessageBox( hWnd, testdata, "text", 0);
			}

			ic = 0;
			for ( ib=0; ib<(int)MTRLEN(hyo[ih*Col_no+iw].text.data); ib++ ) {
				if ( hyo[ih*Col_no+iw].text.data[ib] != '#' ) {
					ic = 1;
					break;
				}
			}
			if ( ic == 0 ) {
//------------------------------------------------------------------------------
//Nbv{[hփRs[
//------------------------------------------------------------------------------
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_METHOD, &result, ExCell.pdispVal, L"Copy", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
					VariantClear(&result);
				}

				if ( ClipRead( &clip_data ) != NOMAL_RETURN ) {
					irc = ExcelEnd(1);
					FreeArea();
					return -1;
				}
				Clip_alloc = 1;
				if ( MTRLEN(clip_data) >= 2 ) clip_data[MTRLEN(clip_data)-2] = '\0';
				if ( hyo[ih*Col_no+iw].text.size < (int)MTRLEN(clip_data) ) {
					CharLenFree(&hyo[ih*Col_no+iw].text);
					sizew = MTRLEN(clip_data);
					if ( CharLenNewAlloc(&hyo[ih*Col_no+iw].text, sizew) == MEMORY_ERROR ) {
						irc = ExcelEnd(1);
						FreeArea();
						return MEMORY_ERROR;
					}
				}
				MTRCPY(hyo[ih*Col_no+iw].text.data, hyo[ih*Col_no+iw].text.size+1, clip_data);
				delete[] clip_data;
				Clip_alloc = 0;
			}

//------------------------------------------------------------------------------
//ʒu荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExCell.pdispVal, L"HorizontalAlignment", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				hyo[ih*Col_no+iw].h_ichi = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "ʒu", 0);
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//ʒu荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExCell.pdispVal, L"VerticalAlignment", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				hyo[ih*Col_no+iw].v_ichi = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "cʒu", 0);
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//Z̕F̑荞
//------------------------------------------------------------------------------
// L"Size" ̂Ƃ      result.vt = VT_R8 = 5      (int)result.dblVal  Ŏo
// L"Color" ̂Ƃ     result.vt = VT_R8 = 5      (int)result.dblVal  Ŏo
// L"Underline" ̂Ƃ result.vt = VT_I4 = 3      (int)result.lVal    Ŏo
// L"Bold" ̂Ƃ      result.vt = VT_BOOL = 11   (int)result.boolVal Ŏo

//Color RGB    B 00FF0000    G 0000FF00    R 000000FF
#if defined(_WIKI) || defined(_HTML)
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExFont.pdispVal, L"Color", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				hyo[ih*Col_no+iw].fcolor = (int)result.dblVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %x", result.vt, (int)result.dblVal);
//MessageBox( hWnd, testdata, "font color", 0);
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//Z̑̕傫荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExFont.pdispVal, L"Size", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				hyo[ih*Col_no+iw].size = (int)result.dblVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%x %d", result.vt, (int)result.dblVal);
//MessageBox( hWnd, testdata, "size", 0);
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//Z̑荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExFont.pdispVal, L"Bold", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				if ( result.boolVal) {
					hyo[ih*Col_no+iw].bold = TRUE;
//MessageBox( hWnd, "true", "bold", 0);
				} else {
					hyo[ih*Col_no+iw].bold = FALSE;
//MessageBox( hWnd, "false", "bold", 0);
				}
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//Z̉荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExFont.pdispVal, L"Underline", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				hyo[ih*Col_no+iw].underline = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%x %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "Underline", 0);
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//Z̎荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExFont.pdispVal, L"Strikethrough", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				if ( result.boolVal) {
					hyo[ih*Col_no+iw].strikethrough = 1;//
//MessageBox( hWnd, "true", "Strikethrough", 0);
				} else {
					hyo[ih*Col_no+iw].strikethrough = 0;//Ȃ
//MessageBox( hWnd, "false", "Strikethrough", 0);
				}
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//Z̎Α̎荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExFont.pdispVal, L"Italic", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				if ( result.boolVal) {
					hyo[ih*Col_no+iw].italic = TRUE;
//MessageBox( hWnd, "true", "Italic", 0);
				} else {
					hyo[ih*Col_no+iw].italic = FALSE;
//MessageBox( hWnd, "false", "Italic", 0);
				}
				VariantClear(&result);
			}
			VariantClear(&ExFont);//ŃNA
			Use_flag[USE_FONT] = 0;

//------------------------------------------------------------------------------
//Z̔wiF̑荞
//------------------------------------------------------------------------------
//Color RGB    B 00FF0000    G 0000FF00    R 000000FF
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExInterior.pdispVal, L"Color", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				hyo[ih*Col_no+iw].bcolor = (int)result.dblVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %x", result.vt, (int)result.dblVal);
//MessageBox( hWnd, testdata, "back color", 0);
				VariantClear(&result);
			}
//------------------------------------------------------------------------------
//Z̔wiF̑荞
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExInterior.pdispVal, L"Pattern", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
				if ( (int)result.lVal != xlSolid ) {//hԂȊO͐FZbg
					hyo[ih*Col_no+iw].bcolor = 0x00ffffff;
				}
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %x", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "Pattern", 0);
				VariantClear(&result);
			}

#endif
			VariantClear(&ExInterior);//ŃNA
			Use_flag[USE_INTERIOR] = 0;

			for ( ip=0; ip<4; ip++ ) {
//------------------------------------------------------------------------------
//Z̐̃CX^X荞
//------------------------------------------------------------------------------
				{
					VARIANT ix;
					VariantInit(&ExBod);
					Use_flag[USE_BOD] = 1;
					VariantInit(&ix);
					ix.vt   = VT_I4;
					ix.lVal = ip+1;
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExBod, ExCell.pdispVal, L"Borders", 1, ix) != 0 ) {
						VariantClear(&ix);
						VariantClear(&ExBod);
						Use_flag[USE_BOD] = 0;
						return OLE_ERROR;
					}
					VariantClear(&ix);
//					VariantClear(&ExBod);//ŃNA
//					Use_flag[USE_BOD] = 0;
				}

//------------------------------------------------------------------------------
//Z̐̑荞
//------------------------------------------------------------------------------
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExBod.pdispVal, L"LineStyle", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
					hyo[ih*Col_no+iw].style[ip] = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "", 0);
					VariantClear(&result);
				}

//------------------------------------------------------------------------------
//Z̐̕荞
//------------------------------------------------------------------------------
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExBod.pdispVal, L"Weight", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
					hyo[ih*Col_no+iw].weight[ip] = (int)result.lVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %d", result.vt, (int)result.lVal);
//MessageBox( hWnd, testdata, "", 0);
					VariantClear(&result);
				}

//------------------------------------------------------------------------------
//ŽrF̐F荞
//------------------------------------------------------------------------------
//Color RGB    B 00FF0000    G 0000FF00    R 000000FF
#if defined(_WIKI) || defined(_HTML)
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExBod.pdispVal, L"Color", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
					hyo[ih*Col_no+iw].lcolor[ip] = (int)result.dblVal;
//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%d %x", result.vt, (int)result.dblVal);
//MessageBox( hWnd, testdata, "line color", 0);
					VariantClear(&result);
				}
#endif
				VariantClear(&ExBod);//ŃNA
				Use_flag[USE_BOD] = 0;

			}

			if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 0 ) {
//------------------------------------------------------------------------------
//Z͈̔͂̃CX^X荞
//------------------------------------------------------------------------------
				{
					VariantInit(&ExMearge);
					Use_flag[USE_MEARGE] = 1;
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &ExMearge, ExCell.pdispVal, L"MergeArea", 0) != 0 ) {
						VariantClear(&ExMearge);
						Use_flag[USE_MEARGE] = 0;
						return OLE_ERROR;
					}
//					VariantClear(&ExMearge);//ŃNA
//					Use_flag[USE_MEARGE] = 0;
				}

//------------------------------------------------------------------------------
//Z͈͎̔荞
//------------------------------------------------------------------------------
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ExMearge.pdispVal, L"Address", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}

#ifdef _UNICODE_TABLE
				sizew = MTRLEN(result.bstrVal);

				MTRNCPY( mergestr, sizeof(mergestr), result.bstrVal, sizew);
				mergestr[sizew] = LIT_NULL_C;
#else  //_UNICODE_TABLE
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew = wcstombs( NULL, (wchar_t*)result.bstrVal, 0);
#else  //MSC
				wcstombs_s( &sizew, NULL, 0, (wchar_t*)result.bstrVal, 0);
#endif  //MSC
				if ( sizew == -1 ) {
					irc = MessageDisp( MSG_ER_CHAR_CODE );
					VariantClear(&result);
					irc = ExcelEnd(1);
					FreeArea();
					return FINISHING_MESSAGE;
				}

				UNICHAR *str;
				try{
					str = new UNICHAR[sizew+1];
				}
				catch (...) {
					irc = MessageDisp( MSG_ER_MEM3_CODE );
					VariantClear(&result);
					irc = ExcelEnd(1);
					FreeArea();
					return FINISHING_MESSAGE;
				}
				str[0] = '\0';
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew2 = wcstombs( str, (wchar_t*)result.bstrVal, sizew + 1);
#else  //MSC
				wcstombs_s( &sizew2, str, sizew+1, (wchar_t*)result.bstrVal, sizew + 1);
#endif  //MSC
				str[sizew] = LIT_NULL_C;
				MTRCPY( mergestr, sizeof(mergestr), str);
				delete str;
#endif  //_UNICODE_TABLE


//char testdata[300];
//SPRINTF(testdata, sizeof(testdata), "%s", mergestr);
//MessageBox( hWnd, testdata, "͈", 0);
					VariantClear(&result);
				}
				VariantClear(&ExMearge);//ŃNA
				Use_flag[USE_MEARGE] = 0;

				Cell_no_get(mergestr, &hyo[ih*Col_no+iw].merge[0]);
				if ( hyo[ih*Col_no+iw].merge[AR_FLAG] != 0 ) {
					for( iw2=hyo[ih*Col_no+iw].merge[AR_LEFT]; iw2<=hyo[ih*Col_no+iw].merge[AR_RIGHT]; iw2++ ) {
						for( ih2=hyo[ih*Col_no+iw].merge[AR_TOP]; ih2<=hyo[ih*Col_no+iw].merge[AR_BOTTOM]; ih2++ ) {
							if ( iw2 == hyo[ih*Col_no+iw].merge[AR_LEFT] ) {
								hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 1;
							} else if ( iw2 == hyo[ih*Col_no+iw].merge[AR_RIGHT] ) {
								hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 3;
							} else {
								hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 2;
							}
							if ( ih2 == hyo[ih*Col_no+iw].merge[AR_TOP] ) {
							} else if ( ih2 == hyo[ih*Col_no+iw].merge[AR_BOTTOM] ) {
								hyo[ih2*Col_no+iw2].merge[AR_FLAG] = hyo[ih2*Col_no+iw2].merge[AR_FLAG] + 6;
							} else {
								hyo[ih2*Col_no+iw2].merge[AR_FLAG] = hyo[ih2*Col_no+iw2].merge[AR_FLAG] + 3;
							}
							hyo[ih2*Col_no+iw2].merge[AR_BASE] = ih*Col_no+iw;
						}
					}
				}
				VariantClear(&ExCell);//ŃNA
				Use_flag[USE_CELL] = 0;
			}
		}
		if ( Break_flag == 1 ) {
			irc = MessageDisp( MSG_CANCLE_CODE );
			irc = ExcelEnd(1);
			FreeArea();
			Break_flag = 2;
			return CANCEL_RETURN;
		}
		ProgressView(30 + (ih * sabun) / 1000);
	}

	ProgressView(90);
	ExcelEnd(1);

	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	return NOMAL_RETURN;
}
